/*!
	Document:      slideshow_view.js
	Date started:  05 Feb 2013
	By:            Matt Fozard
	Purpose:       Quru Image Server image slideshow library
	Requires:      common_view.js
	Copyright:     Quru Ltd (www.quru.com)
	Licence:

	This program is free software: you can redistribute it and/or modify
	it under the terms of the GNU Affero General Public License as published
	by the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU Affero General Public License for more details.

	You should have received a copy of the GNU Affero General Public License
	along with this program.  If not, see http://www.gnu.org/licenses/
*/
Math.easeInOutQuad=function(e,a,g,f){if((e/=f/2)<1){return g/2*e*e+a;
}return -g/2*((--e)*(e-2)-1)+a;};function ImgSlideshow(a,b){this.options={controls:true,dots:true,dotColor:"#666666",dotSelectedColor:"#dddddd",mode:"slide",delay:5,pauseOnHover:true,server:"",folder:"",images:[],params:{},duration:1000,bgColor:"white",easeFn:Math.easeInOutQuad};
if(b!=undefined){this.options=QU.merge(this.options,b);}this.options.server=this._add_slash(this.options.server);
this.options.folder=this._add_slash(this.options.folder);this.options.images.forEach(function(c){if(c.server){c.server=this._add_slash(c.server);
}}.bind(this));this.imageSize={width:0,height:0};this.ctrEl=QU.id(a);this._hover_in_fn=this._hover_in.bind(this);
this._hover_out_fn=this._hover_out.bind(this);this._visibility_change_fn=this._visibility_change.bind(this);
this.pvAPI=(document.hidden!==undefined);this.dotEls=[];this.arrowEls=[];this.imageEls=[];this.wrapEls=[];
this.animTimer=null;this.ready=false;this.running=false;this.animating=false;this.animator=new ElementAnimation(this.options.duration,this.options.easeFn);
this.direction=1;this.imageIdx=0;this.layout();}ImgSlideshow.prototype.init=function(){this.setMessage("Loading slideshow...");
if(this.options.folder){this.addFolderImages();}else{this.onDataReady(null);}if(this.options.controls){var c=["arrow-left.png","arrow-right.png"],b=[this.prev.bind(this),this.next.bind(this)];
for(var a=0;a<c.length;a++){var d=document.createElement("a");d.href="#";d.innerHTML='<img src="'+this.options.server+"static/images/slideshow/"+c[a]+'"> ';
QU.elSetStyles(d,{position:"absolute",zIndex:"10",textDecoration:"none",border:"none"});d._onclick=b[a];
d.addEventListener("click",d._onclick,false);this.arrowEls[a]=d;}}};ImgSlideshow.prototype.destroy=function(){if(this.pvAPI){document.removeEventListener("visibilitychange",this._visibility_change_fn,false);
}if(this.options.pauseOnHover){this.ctrEl.removeEventListener("mouseenter",this._hover_in_fn,false);this.ctrEl.removeEventListener("mouseleave",this._hover_out_fn,false);
}this.stop();this.ready=false;var a=[this.dotEls,this.arrowEls,this.imageEls,this.wrapEls];a.forEach(function(b){b.forEach(function(c){if(c._onclick){c.removeEventListener("click",c._onclick,false);
}if(c._onload){c.removeEventListener("load",c._onload,false);}QU.elRemove(c);});b.length=0;});QU.elClear(this.ctrEl);
};ImgSlideshow.prototype.layout=function(){var a=QU.elInnerSize(this.ctrEl,false);this.imageSize.width=a.width;
this.imageSize.height=a.height;QU.elSetStyles(this.ctrEl,{position:"relative",overflow:"hidden",textAlign:"center",lineHeight:a.height+"px"});
};ImgSlideshow.prototype.setMessage=function(a){this.ctrEl.innerHTML='<span style="font-size: small">'+a+"</span>";
};ImgSlideshow.prototype.addFolderImages=function(){var a=this.options.server+"api/v1/list/?path="+encodeURIComponent(this.options.folder);
QU.jsonRequest(a,"GET",function(c,b){this.onDataReady(b);}.bind(this),function(c,b){this.setMessage("");
}.bind(this)).send();};ImgSlideshow.prototype.onDataReady=function(h){if(h&&(h.status==200)){for(var a=0;
a<h.data.length;a++){var e=h.data[a];if(e.supported){this.options.images.push({src:this.options.folder+e.filename});
}}}if((this.options.images.length>0)&&(this.imageSize.width>0)&&(this.imageSize.height>0)){for(var a=0;
a<this.options.images.length;a++){var f=this.options.images[a],b={};b=QU.merge(b,this.options.params);
b=QU.merge(b,f);delete b.url;delete b.server;b.width=this.imageSize.width;b.height=this.imageSize.height;
b.autosizefit=1;b.strip=1;if(!b.format){b.format="jpg";}var d=f.server?f.server:this.options.server;var c=d+"image?"+QU.ObjectToQueryString(b);
var g=document.createElement("img");g._onload=this.onImageReady.bind(this);g.addEventListener("load",g._onload,false);
g.setAttribute("data-index",a);g.src=c;g.style.margin="0";g.style.padding="0";g.style.verticalAlign="top";
this.imageEls.push(g);}}else{this.setMessage("");}};ImgSlideshow.prototype.onImageReady=function(c){var b=c.target;
var a=Math.floor((this.imageSize.height-b.height)/2);b.style.marginTop=a+"px";if(b.getAttribute("data-index")==="0"){setTimeout(this.create_ui.bind(this),1);
}};ImgSlideshow.prototype.create_ui=function(){var d={border:"none",display:"block",width:this.imageSize.width+"px",height:this.imageSize.height+"px",margin:"0",padding:"0",fontSize:"0",lineHeight:"0",position:"absolute",top:"0px",left:"0px",visibility:"hidden"};
if(this.options.mode==="stack"){d.backgroundColor=this.options.bgColor;}for(var b=0;b<this.imageEls.length;
b++){if(this.options.images[b].url){var c=document.createElement("a");c.href=this.options.images[b].url;
}else{var c=document.createElement("div");}QU.elSetStyles(c,d);c.appendChild(this.imageEls[b]);this.wrapEls.push(c);
}QU.elClear(this.ctrEl);for(var b=0;b<this.wrapEls.length;b++){this.ctrEl.appendChild(this.wrapEls[b]);
}if(this.arrowEls.length===2){this.arrowEls[0].style.left="10px";this.arrowEls[1].style.right="10px";
this.ctrEl.appendChild(this.arrowEls[0]);this.ctrEl.appendChild(this.arrowEls[1]);}if(this.options.dots){var e=document.createElement("div");
QU.elSetStyles(e,{position:"absolute",width:"100%",height:"20px",lineHeight:"20px",textAlign:"center",zIndex:"10",fontFamily:"sans-serif",fontSize:"20px",left:"0px",bottom:"5px"});
for(var b=0;b<this.wrapEls.length;b++){var a=document.createElement("a");a.href="#";a.innerHTML="&#9679;";
a.className="_sls_dot";a.setAttribute("data-index",b);a.style.margin="0 8px 0 8px";a.style.textDecoration="none";
a.style.border="none";a._onclick=function(g,f){return function(h){h.preventDefault();return this.index(g);
}.bind(f);}(b,this);a.addEventListener("click",a._onclick,false);this.dotEls.push(a);e.appendChild(a);
}this.ctrEl.appendChild(e);}this.wrapEls[0].style.visibility="visible";this._select_dot(0);if(this.options.pauseOnHover){this.ctrEl.addEventListener("mouseenter",this._hover_in_fn,false);
this.ctrEl.addEventListener("mouseleave",this._hover_out_fn,false);}if(this.pvAPI){document.addEventListener("visibilitychange",this._visibility_change_fn,false);
}this.ready=true;this.start();};ImgSlideshow.prototype.start=function(){if(!this.running&&(this.wrapEls.length>1)){this.direction=1;
this.running=true;this._animate_async();}return false;};ImgSlideshow.prototype.stop=function(){if(this.animTimer!==null){clearTimeout(this.animTimer);
this.animTimer=null;}this.running=false;return false;};ImgSlideshow.prototype.prev=function(a){if(a){a.preventDefault();
}if(this.ready&&(this.wrapEls.length>1)&&!this.animating){this.stop();this.direction=-1;this._animate();
}return false;};ImgSlideshow.prototype.next=function(a){if(a){a.preventDefault();}if(this.ready&&(this.wrapEls.length>1)&&!this.animating){this.stop();
this.direction=1;this._animate();}return false;};ImgSlideshow.prototype.index=function(a){a=Math.min(Math.max(a,0),this.wrapEls.length-1);
if(this.ready&&(this.wrapEls.length>1)&&!this.animating){this.stop();this.direction=(a>=this.imageIdx)?1:-1;
this._animate(a);}return false;};ImgSlideshow.prototype._animate=function(a){switch(this.options.mode){case"slide":return this._slide(a);
case"stack":return this._stack(a);case"fade":return this._xfade(a);}};ImgSlideshow.prototype._animate_async=function(){if(this.animTimer===null){this.animTimer=setTimeout(function(){this._animate();
this.animTimer=null;}.bind(this),this.options.delay*1000);}};ImgSlideshow.prototype._slide=function(a){this._do_slide(false,a);
};ImgSlideshow.prototype._stack=function(a){this._do_slide(true,a);};ImgSlideshow.prototype._do_slide=function(a,e){var c=this.imageIdx,b=this.wrapEls.length-1,d=(e!==undefined)?e:c+this.direction;
if(d<0){d=b;}else{if(d>b){d=0;}}if(d===c){return;}this.wrapEls[c].style.zIndex="0";this.wrapEls[d].style.left=(this.imageSize.width*this.direction)+"px";
this.wrapEls[d].style.visibility="visible";this.wrapEls[d].style.zIndex="1";this.animating=true;this.animator.start([{element:this.wrapEls[c],changes:a?[]:[{property:"left",start:0,end:(-this.imageSize.width*this.direction),unit:"px"}]},{element:this.wrapEls[d],changes:[{property:"left",start:(this.imageSize.width*this.direction),end:0,unit:"px"}]},],function(){this.animating=false;
this.wrapEls[c].style.visibility="hidden";if(this.running){this._animate_async();}}.bind(this));this.imageIdx=d;
this._select_dot(this.imageIdx);};ImgSlideshow.prototype._xfade=function(d){var b=this.imageIdx,a=this.wrapEls.length-1,c=(d!==undefined)?d:b+this.direction;
if(c<0){c=a;}else{if(c>a){c=0;}}if(c===b){return;}this.wrapEls[c].style.opacity="0";this.wrapEls[c].style.visibility="visible";
this.animating=true;this.animator.start([{element:this.wrapEls[b],changes:[{property:"opacity",start:1,end:0,unit:""}]},{element:this.wrapEls[c],changes:[{property:"opacity",start:0,end:1,unit:""}]},],function(){this.animating=false;
this.wrapEls[b].style.visibility="hidden";if(this.running){this._animate_async();}}.bind(this));this.imageIdx=c;
this._select_dot(this.imageIdx);};ImgSlideshow.prototype._select_dot=function(a){if(this.options.dots){for(var b=0;
b<this.dotEls.length;b++){var c=this.dotEls[b];c.style.color=(c.getAttribute("data-index")===""+a)?this.options.dotSelectedColor:this.options.dotColor;
}}};ImgSlideshow.prototype._add_slash=function(a){if(a&&a.charAt(a.length-1)!="/"){return a+"/";}else{return a;
}};ImgSlideshow.prototype._hover_in=function(){this.wasRunning=this.running;if(this.running){this.stop();
}};ImgSlideshow.prototype._hover_out=function(){if(this.wasRunning){this.start();}};ImgSlideshow.prototype._visibility_change=function(){(document.hidden?this._hover_in:this._hover_out).bind(this)();
};function ElementAnimation(b,a){this.steps=Math.round(Math.max(1,b/16.66));this.easeFn=a;this.stepFn=this._step.bind(this);
if(window.requestAnimationFrame){this.animate=function(){window.requestAnimationFrame(this.stepFn);};
}else{this.animate=function(){return setTimeout(this.stepFn,17);};}}ElementAnimation.prototype.start=function(a,b){a.forEach(function(c){c.changes.forEach(function(d){d.diff=d.end-d.start;
});});this.spec=a;this.onCompleteFn=b;this.step=0;this.animate();};ElementAnimation.prototype._step=function(){var d,c;
this.step++;for(var b=0;b<this.spec.length;b++){d=this.spec[b];for(var a=0;a<d.changes.length;a++){c=d.changes[a];
d.element.style[c.property]=this.easeFn(this.step,c.start,c.diff,this.steps)+c.unit;}}if(this.step<this.steps){this.animate();
}else{if(this.onCompleteFn){this.onCompleteFn();}}};function slideshow_view_init(b,c){b=QU.id(b);if(b){if(QU.supported){if(b._show!==undefined){b._show.destroy();
}var a=new ImgSlideshow(b,c);a.init();b._show=a;}else{b.innerHTML="Sorry, this control is unsupported. Try upgrading your web browser.";
}}return false;}function slideshow_view_stop(a){a=QU.id(a);if(a&&a._show){return a._show.stop();}}function slideshow_view_start(a){a=QU.id(a);
if(a&&a._show){return a._show.start();}}function slideshow_view_prev(a){a=QU.id(a);if(a&&a._show){return a._show.prev();
}}function slideshow_view_next(a){a=QU.id(a);if(a&&a._show){return a._show.next();}}function slideshow_view_index(a,b){a=QU.id(a);
if(a&&a._show){return a._show.index(b);}}
/*!
    Document:      common_view.js
    Date started:  12 September 2017
    By:            Matt Fozard
    Purpose:       Quru Image Server viewer utilities and common routines
    Requires:
    Copyright:     Quru Ltd (www.quru.com)
    Licence:

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU Affero General Public License as published
    by the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Affero General Public License for more details.

    You should have received a copy of the GNU Affero General Public License
    along with this program.  If not, see http://www.gnu.org/licenses/
*/
if(!window.QU){QU={version:1,supported:([].forEach!==undefined)&&([].indexOf!==undefined)&&((function(){}).bind!==undefined)&&(Object.keys!==undefined)&&(window.addEventListener!==undefined)&&(window.getComputedStyle!==undefined)&&(window.pageXOffset!==undefined)&&(window.JSON!==undefined)};
QU.id=function(a){if(typeof a==="number"){a=""+a;}if(typeof a==="string"){return document.getElementById(a);
}if(typeof a==="object"){return a;}return null;};QU.elClear=function(a){a=QU.id(a);while(a.firstChild){a.removeChild(a.firstChild);
}return a;};QU.elRemove=function(a){a=QU.id(a);if(a.parentNode){a.parentNode.removeChild(a);}return a;
};QU.elOuterPosition=function(c){c=QU.id(c);var d=c,a=0,b=0;if(d.offsetParent){do{a+=d.offsetLeft;b+=d.offsetTop;
}while(d=d.offsetParent);}return{x:a,y:b,width:c.offsetWidth,height:c.offsetHeight};};QU.elInnerSize=function(c,a){c=QU.id(c);
var d={width:c.clientWidth,height:c.clientHeight};if(!a){var b=window.getComputedStyle(c);d.width-=Math.round(parseFloat(b.paddingLeft)+parseFloat(b.paddingRight));
d.height-=Math.round(parseFloat(b.paddingTop)+parseFloat(b.paddingBottom));d.width=Math.max(d.width,0);
d.height=Math.max(d.height,0);}return d;};QU.elInnerOffsets=function(b){b=QU.id(b);var a=window.getComputedStyle(b);
return{left:Math.round(parseFloat(a.paddingLeft)+parseFloat(a.borderLeftWidth)),right:Math.round(parseFloat(a.paddingRight)+parseFloat(a.borderRightWidth)),top:Math.round(parseFloat(a.paddingTop)+parseFloat(a.borderTopWidth)),bottom:Math.round(parseFloat(a.paddingBottom)+parseFloat(a.borderBottomWidth))};
};QU.elSetClass=function(d,c,e){d=QU.id(d);if(d.classList){if(e){d.classList.add(c);}else{d.classList.remove(c);
}}else{var b=d.className.split(" "),a=b.indexOf(c);if(b.length===1&&b[0]===""){b.length=0;}if(e&&(a===-1)){b.push(c);
}else{if(!e&&(a!==-1)){b.splice(a,1);}}d.className=b.join(" ");}return d;};QU.elHasClass=function(c,b){c=QU.id(c);
if(c.classList){return c.classList.contains(b);}else{var a=c.className.split(" ");return a.indexOf(b)!==-1;
}};QU.elGetStyles=function(c,g){c=QU.id(c);var b,f={};if(g){try{b=window.getComputedStyle(c);}catch(d){}if(b){for(var a=0;
a<g.length;a++){f[g[a]]=b[g[a]];}}}return f;};QU.elSetStyles=function(b,c){b=QU.id(b);if(c){for(var a in c){b.style[a]=c[a];
}}return b;};QU.evPosition=function(b){var c={x:0,y:0},a={x:0,y:0};if(b.type.indexOf("touch")==0||b.type.indexOf("gesture")==0){if(b.touches&&b.touches[0]){var e=b.touches[0];
c.x=e.pageX;c.y=e.pageY;a.x=e.clientX;a.y=e.clientY;}}else{var d=document.documentElement||document.body;
c.x=(b.pageX!=null)?b.pageX:b.clientX+d.scrollLeft;c.y=(b.pageY!=null)?b.pageY:b.clientY+d.scrollTop;
a.x=(b.pageX!=null)?b.pageX-window.pageXOffset:b.clientX;a.y=(b.pageY!=null)?b.pageY-window.pageYOffset:b.clientY;
}return{page:c,viewport:a};};QU.jsonRequest=function(b,e,a,d){var c=new XMLHttpRequest();if("withCredentials" in c){c.open(e,b,true);
c.setRequestHeader("Accept","application/json");}else{if(typeof XDomainRequest!=="undefined"){c=new XDomainRequest();
c._XDR=true;c.onprogress=function(){};c.ontimeout=function(){};c.open(e,b);}else{return null;}}c.onload=function(){if(!c._XDR&&(c.status<200||c.status>=400)){if(d){d(c,c.responseText);
}return;}if(a){var g;try{g=JSON.parse(c.responseText);}catch(f){if(d){d(c,"Invalid JSON: "+f);}return;
}a(c,g);}};c.onerror=function(){if(d){d(c,c.responseText);}};return c;};QU.splitURL=function(d){var a,c,b,e={protocol:"",server:"",path:"",query:"",fragment:""};
a=d.indexOf("//");if(a!==-1){e.protocol=d.substring(0,a+2);d=d.substring(a+2);}a=d.indexOf("/");if(a>=1){e.server=d.substring(0,a);
d=d.substring(a);}c=d.indexOf("?");if(c!==-1){e.path=d.substring(0,c);e.query=d.substring(c+1);b=e.query.indexOf("#");
if(b!==-1){e.fragment=e.query.substring(b+1);e.query=e.query.substring(0,b);}}else{e.path=d;b=e.path.indexOf("#");
if(b!==-1){e.fragment=e.path.substring(b+1);e.path=e.path.substring(0,b);}}return e;};QU.ObjectToQueryString=function(a,c){var d=[];
var b=Object.keys(a);b.forEach(function(g){var h=a[g],f;if(c){g=c+"["+g+"]";}switch(typeof h){case"object":f=QU.ObjectToQueryString(h,g);
break;case"array":var e={};h.forEach(function(k,j){e[j]=k;});f=QU.ObjectToQueryString(e,g);break;default:f=g+"="+encodeURIComponent(h);
}if(h!=null){d.push(f);}});return d.join("&");};QU.QueryStringToObject=function(g,d){if(d===undefined){d=true;
}var a=function(h){return decodeURIComponent(h.replace(/\+/g," "));};var f=true,b=true;var e=g.split(/[&;]/),c={};
if(!e.length){return c;}e.forEach(function(l){var h=l.indexOf("=")+1,j=h?l.substr(h):"",i=h?l.substr(0,h-1).match(/([^\]\[]+|(\B)(?=\]))/g):[l],k=c;
if(!i){return;}if(!d&&!j){return;}if(b){j=a(j);}i.forEach(function(n,m){if(f){n=a(n);}var o=k[n];if(m<i.length-1){k=k[n]=o||{};
}else{if(typeof o==="array"){o.push(j);}else{k[n]=o!=null?[o,j]:j;}}});});return c;};QU.whenReady=function(a){if(document.attachEvent?document.readyState==="complete":document.readyState!=="loading"){a();
}else{document.addEventListener("DOMContentLoaded",a);}};QU.clone=function(a){if((a===null)||(a===undefined)){return a;
}return JSON.parse(JSON.stringify(a));};QU.merge=function(f,e){var d=function(h,i,j){switch(typeof j){case"object":if(typeof h[i]=="object"){QU.merge(h[i],j);
}else{h[i]=QU.clone(j);}break;case"array":h[i]=QU.clone(j);break;default:h[i]=j;}return h;};for(var c=1,a=arguments.length;
c<a;c++){var g=arguments[c];if((g!==null)&&(g!==undefined)){for(var b in g){d(f,b,g[b]);}}}return f;};
}